/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2014, Romain Quey. */
/* See the COPYING file in the top-level directory. */

/// \file neut_elt.h
/// \brief Get properties of mesh elements
/// \author Romain Quey
/// \bug No known bugs

#ifndef NEUT_ELT_H
#define NEUT_ELT_H

extern void neut_elt_name_prop (char *, char *, char *, int *, int *);
extern int neut_elt_nodeqty (char *, int, int);
extern int neut_elt_boundqty (char *, int);
extern int neut_elt_dim_gtype_order (int, int);
extern int neut_elt_order (char *, int, int);
extern int neut_elt_gtype_prop (int, char *, int *, int *);
extern double neut_elt_rr_3d (double *, double *, double *, double *);
extern double neut_elt_rr_2d (double *, double *, double *);
extern double neut_elt_3d_rho (double *, double *, double *, double *);
extern int neut_elt_boundlist (char *type, int dim, int ***pfaces,
			       int *pfaceqty, int *pnodeqty);

#endif /* NEUT_ELT_H */
