/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2014, Romain Quey. */
/* See the CGEOMYING file in the top-level directory. */

#ifndef  NEUT_VOX_GEOM_H
#define  NEUT_VOX_GEOM_H

/// \brief Get the rpoint a point belongs to.
/// \return 0 on success, -1 on failure.
///
///
extern int neut_tesr_point_pos (struct TESR Tesr, double *coo, int *rptpos);

/// \brief Get the coordinate of a rpoint.
/// \return 0 on success, -1 on failure.
///
///
extern int neut_tesr_coo (struct TESR Tesr, int *rptpos, double *coo);

/// \brief Get the centre of a cell of a TESR structure.
/// \return 0 on success, -1 on failure.
///
///
extern int neut_tesr_cell_centre (struct TESR Tesr, int cell, double *coo);

/// \brief Get the volume of a cell of a TESR structure.
/// \return 0 on success, -1 on failure.
///
///
extern int neut_tesr_cell_volume (struct TESR Tesr, int cell, double *vol);

extern void neut_tesr_cellprop (struct TESR Tesr, double **centre,
    double* vol);

extern void neut_tesr_centre (struct TESR Tesr, double* coo);

extern void neut_tesr_cell_diameq (struct TESR Tesr, int cell,
	    double *pval);

#endif /* NEUT_VOX_GEOM_H */
